/**
 * Copyright (c) 2004-2015, Istvan David, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Istvan David - initial API and implementation
 */
package org.eclipse.viatra.cep.core.metamodels.automaton;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Typed Transition</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.viatra.cep.core.metamodels.automaton.TypedTransition#getGuards <em>Guards</em>}</li>
 *   <li>{@link org.eclipse.viatra.cep.core.metamodels.automaton.TypedTransition#getParameters <em>Parameters</em>}</li>
 * </ul>
 *
 * @see org.eclipse.viatra.cep.core.metamodels.automaton.AutomatonPackage#getTypedTransition()
 * @model
 * @generated
 */
public interface TypedTransition extends Transition {
	/**
	 * Returns the value of the '<em><b>Guards</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra.cep.core.metamodels.automaton.Guard}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.viatra.cep.core.metamodels.automaton.Guard#getTransition <em>Transition</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Guards</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Guards</em>' containment reference list.
	 * @see org.eclipse.viatra.cep.core.metamodels.automaton.AutomatonPackage#getTypedTransition_Guards()
	 * @see org.eclipse.viatra.cep.core.metamodels.automaton.Guard#getTransition
	 * @model opposite="transition" containment="true" required="true"
	 * @generated
	 */
	EList<Guard> getGuards();

	/**
	 * Returns the value of the '<em><b>Parameters</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra.cep.core.metamodels.automaton.Parameter}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.viatra.cep.core.metamodels.automaton.Parameter#getTransition <em>Transition</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parameters</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Parameters</em>' containment reference list.
	 * @see org.eclipse.viatra.cep.core.metamodels.automaton.AutomatonPackage#getTypedTransition_Parameters()
	 * @see org.eclipse.viatra.cep.core.metamodels.automaton.Parameter#getTransition
	 * @model opposite="transition" containment="true"
	 * @generated
	 */
	EList<Parameter> getParameters();

} // TypedTransition
